var _excluded = ["readOnly", "disabled", "checked", "on", "off", "size", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useImperativeHandle, forwardRef, useRef } from 'react';

// 内库使用-start
import DOMUtil from "./../../utils/DOMUtil";
// 内库使用-end

/* 测试使用-start
import { DOMUtil } from 'seedsui-react'
测试使用-end */

// 开关控件
var Switch = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var readOnly = _ref.readOnly,
    disabled = _ref.disabled,
    checked = _ref.checked,
    on = _ref.on,
    off = _ref.off,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'm' : _ref$size,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // 节点
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: DOMUtil.classNames('switch', size, props.className, checked ? 'active' : '', readOnly ? 'readOnly' : '', disabled ? 'disabled' : disabled),
    onClick: function onClick(e) {
      if (onChange) onChange(!checked);
      e.stopPropagation();
    },
    ref: rootRef
  }), /*#__PURE__*/React.createElement("div", {
    className: "switch-handle"
  }), /*#__PURE__*/React.createElement("div", {
    className: "switch-inner"
  }, /*#__PURE__*/React.createElement("div", {
    className: "switch-on"
  }, on), /*#__PURE__*/React.createElement("div", {
    className: "switch-off"
  }, off)));
});
export default Switch;